import es, popuplib, random, services, cfglib


# Config

config = cfglib.AddonCFG(es.getAddonPath("dissolver") + "/dissolver.cfg")
config.text("********************")
config.text(" Dissolver Settings ")
config.text("********************")
dissolve_deathtype = config.cvar("dissolve_deathtype",      2, "Death Type: 1 = no dissovle, 2 =  Energy Effect ,3 = Heavy Electrical Effect, 4 = Light Electrical  Effect,5 = Core Effect,6 = Random")
dissolve_command = config.cvar("dissolve_command",      '!dissolve', "What you type to bring up the menu")
dissolve_delay = config.cvar("dissolve_delay",      2, "How long before the body dissolves or is removed")

config.write()
# Config

# Public #
info = es.AddonInfo()
info.name     = "Dissolver"
info.version  = "0.3"
info.url      = "http://addons.eventscripts.com/addons/view/sic_dissolver"
info.basename = "sic_dissolver"
info.author   = "sicman_adrian"
es.ServerVar('sic_dissolver', info.version, 'Body Dissolver').makepublic()
#Public#
gamename = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').rsplit('/',1)[~0]
ragdoll = {'cstrike':'cs_ragdoll', 'hl2dm':'hl2dm_ragdoll', 'tf':'tf_ragdoll', 'dod':'dod_ragdoll'}.get(gamename)

def load():
    deathtypemenu = popuplib.create('deathtypemenu')
    deathtypemenu.addline('Dissolver Options')
    deathtypemenu.addline('-----------------------')
    deathtypemenu.addline('->1. No Dissovle')
    deathtypemenu.addline('->2. Energy Effect')
    deathtypemenu.addline('->3. Heavy Electrical Effect')
    deathtypemenu.addline('->4. Light Electrical')
    deathtypemenu.addline('->5. Core Effect')
    deathtypemenu.addline('->6. Random')
    deathtypemenu.addline('->0. Exit')
    deathtypemenu.addline('------------------------')
    deathtypemenu.menuselect = deathtypemenu_menuselect
    setup_auth()
    if not es.exists('saycommand', dissolve_command):
        es.regsaycmd(dissolve_command, 'dissolver/sendpopup')
    config.execute()

def unload():
    if es.exists('saycommand', dissolve_command):
        es.unregsaycmd(dissolve_command)

def deathtypemenu_menuselect (userid, choice, popupid):
    global dissolve_deathtype
    if choice in [1,2,3,4,5,6]:
        dissolve_deathtype = choice
        popuplib.send('deathtypemenu', userid)

def player_death(ev):
    userid = int(ev['userid'])
    if dissolve_deathtype == 6:
        mode = random.randint(1,5)
    else:
        mode = dissolve_deathtype
    dissolve(userid, mode)

def dissolve(userid, mode):
    if mode == 1:
          es.delayed(dissolve_delay, 'es_fire %s %s kill' % (userid, ragdoll))
          es.msg('1')
    else:
          es.delayed(dissolve_delay, 'es_give %s env_entity_dissolver' % userid)
          es.delayed(dissolve_delay, 'es_fire %s env_entity_dissolver AddOutput "target %s"' % (userid, ragdoll))
          es.delayed(dissolve_delay, 'es_fire %s env_entity_dissolver AddOutput "magnitude 1"' % userid)
          es.delayed(dissolve_delay, 'es_fire %s env_entity_dissolver AddOutput "dissolvetype %s"' % (userid,mode-2))
          es.delayed(dissolve_delay, 'es_fire %s env_entity_dissolver Dissolve' % userid) 
          es.msg('2')

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('dissolve_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'dissolve_admin')
    else:
        isAuthed = lambda x: False

def sendpopup():
    userid = es.getcmduserid()
    if isAuthed(userid):
        popuplib.send('deathtypemenu', userid)
    else:
        es.tell(userid, '#multi','#lightgreen [Dissolver] #greenYou are not authorised to run the command admin!') 